#!/usr/bin/perl
use strict;
use warnings;
use Curses;
use LWP::Simple;

my $id = 0;

if (not($ARGV[0])){
	die "You should insert url as parameter. (try -h for more info?)\n";
}
if ($ARGV[0] eq "\-h" || $ARGV[0] eq "\-\-help"){
	print "This is client for Treasure hunters game.\n";
	print "Use server url as parameter.\n\n";
	print "(for example \"". $0 ." localhost:8000\")\n\n";
	print "You can use wasd keys as controls.\n";
	die "DO NOT COLLECT TREASURE (it will crash!)\n";
}
my $data = get($ARGV[0] . '/start')	#initialization
	or die "Wrong url?";
my($x, $y) = (0, 0);
my $treasure = 0;
my $collected = 0;
my @map = ();
$data =~ /([0-9]+)/;	#load game  id
$id = $1;
$data =~ s/([0-9]+)\s+//;
$data =~ /([0-9]+)/;
			#load number of steps
my $total = $1;
my $left = $total;
$data =~ s/([0-9]*)\s+//;
loadmap();
#load data about treasure and position
$data =~ /([0-9]+)\s([0-9]+)\s([0-9+])\s([0-9]+)/;
my $posx = $1;
my $posy = $2;
$treasure = $3;
$collected = $4;

initscr();	#initialization of curses
noecho();
curs_set(0);
&printmap();	#print map
addstr($posy+2, $posx*2+2, '@@');	#print rest of indicators
addstr(1, 6, $treasure);
addstr(1, 10, $collected);
addstr(1, 14, $left . '/' . $total);
refresh();
while ($left != 0){
	my $cmd = getchar();
	if ($cmd eq 'd'){
		$data = get($ARGV[0] . '/tah?id=' . $id . '&pohyb=p');
		&domove();
	} elsif ($cmd eq 'w') {
		$data = get($ARGV[0] . '/tah?id=' . $id . '&pohyb=n');
		&domove();
	} elsif ($cmd eq 's') {
		$data = get($ARGV[0] . '/tah?id=' . $id . '&pohyb=d');
		&domove();
	} elsif ($cmd eq 'a') {
		$data = get($ARGV[0] . '/tah?id=' . $id . '&pohyb=l');
		&domove();
	}
}
endwin();

############################# end of main program ##############################

sub printmap	#pretty self-explaning... huh?
{
	foreach $y (1..10){
		foreach $x (1..10){
			addstr($y+2, $x*2+2, $map[$x][$y]);
		}
	}
}

sub loadmap
{
	while ($y < 10) {
	$y++;
	$x = 0;
	while ($x < 10) {
		$x++;
		$data =~ s/([.+\-0-9X][.+\-0-9X])//;
		$map[$x][$y] = $1;
	}
	$data =~ s/\n//;
	}
}

sub domove
{
	my($x, $y) = (0, 0);
	my $treasure = 0;
	my $collected = 0;
	my @map = ();
	$data =~ /([0-9]+)/;	#load game  id
	$id = $1;
	$data =~ s/([0-9]+)\s+//;
	$data =~ /([0-9]+)/;
				#load number of steps
	my $left = $total;
	$data =~ s/([0-9]*)\s+//;
	loadmap();
	#load data about treasure and position
	$data =~ /([0-9]+)\s([0-9]+)\s([0-9+])\s([0-9]+)/;
	my $posx = $1;
	my $posy = $2;
	$treasure = $3;
	$collected = $4;
	
	&printmap();	#print map
	addstr($posy+2, $posx*2+2, '@@');	#print rest of indicators
	addstr(1, 6, $treasure);
	addstr(1, 10, $collected);
	addstr(1, 14, $left . '/' . $total);
	refresh();
}
